Bug 1849384 - Review Request: swappy - Wayland native snapshot editing tool, inspired by Snappy on macOS
Summary: Review Request: swappy - Wayland native snapshot editing tool, inspired by Sn...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Aleksei Bavshin
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-06-21 07:39 UTC by Bob Hepple
Modified: 2020-07-21 01:56 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-07-09 01:04:54 UTC
Type: ---
alebastr89: fedora-review+


Attachments (Terms of Use)

Description Bob Hepple 2020-06-21 07:39:11 UTC
Spec URL: https://download.copr.fedorainfracloud.org/results/wef/swappy/fedora-31-x86_64/01494494-swappy/swappy.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/wef/swappy/fedora-31-x86_64/01494494-swappy/swappy-1.0.0-1.fc31.src.rpm

Description: 

A Wayland native snapshot and editor tool, inspired by Snappy on macOS. Works great with grim, slurp and sway. But can easily work with other screen copy tools that can output a final PNG image to stdout

Fedora Account System Username: wef

Comment 1 Aleksei Bavshin 2020-06-25 23:13:35 UTC
That's fast! Wasn't swappy released just a few days ago?
I can do a formal review on the weekend. Meanwhile some notes I gathered from spec file and upstream build scripts.

> Version: 1.0.0

Latest upstream version is 1.1.0.

> BuildRequires: cairo-devel
> BuildRequires: pango-devel

BR: pkgconfig(cairo)
BR: pkgconfig(pango)
Maybe also BR: pkgconfig(gio-2.0)

See corresponding section of the guidelines[1] and PR that changes gio to a proper pkgconfig dependency[2]. 

Also, there's an optional support for notifications which you could enable by adding BR: pkgconfig(libnotify)

> Requires: fontawesome-fonts

Requires might be too strong here. Fontawesome could be replaced with other symbol fonts (like Nerd Fonts) and lack of the font does not prevent application from starting.
How about `Recommends: fontawesome-fonts`?
Also: does this work correctly with fontawesome-fonts = 4.7.0 we have in Fedora? Upstream mentions version 5.x of the font.

> %description
I believe there's a rpmlint check somewhere for line width in description. Please, format this to 80 chars per line.

rpmlint may show empty result on the .spec file while also displaying a full screen of errors on the .src.rpm. I recommend to run it on all source and binary packages before sending the review. Also, feel free to ignore most of spelling-error messages (except maybe British spellings, as specs supposed to be in American English). The dictionary rpmlint uses is woefully lacking.

[1] https://docs.fedoraproject.org/en-US/packaging-guidelines/PkgConfigBuildRequires/
[2] https://github.com/jtheoof/swappy/pull/42/files#diff-969b60ad3d206fd45c208e266ccfed38

Comment 2 Bob Hepple 2020-06-26 05:46:35 UTC
Thanks again Aleksei!

SPEC URL: https://download.copr.fedorainfracloud.org/results/wef/swappy/fedora-31-x86_64/01504551-swappy/swappy.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/wef/swappy/fedora-31-x86_64/01504551-swappy/swappy-1.1.0-1.fc31.src.rpm

It seems to work fine with fontawesome-fonts-4.7.0-7.fc31.noarch but I'll try and chase this down with the author and verify.

Comment 3 Aleksei Bavshin 2020-06-27 23:45:40 UTC
Approved.

CSS resource file refers to "FontAwesome 5 Free Solid" and I don't have 4.x installed to confirm that it contains all displayed symbols. I really need to look into updating fontawesome-fonts package with my local changes :(
The gpg key used for release signing doesn't seem to be published anywhere so I'm leaving source verification at your discretion.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[!]: Package contains desktop file if it is a GUI application.
     Will be added in the next upstream release
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: swappy-1.1.0-1.fc33.x86_64.rpm
          swappy-debuginfo-1.1.0-1.fc33.x86_64.rpm
          swappy-debugsource-1.1.0-1.fc33.x86_64.rpm
          swappy-1.1.0-1.fc33.src.rpm
swappy.x86_64: W: spelling-error Summary(en_US) macOS -> ma Cos, mac OS, mac-OS
swappy.x86_64: W: spelling-error %description -l en_US macOS -> ma Cos, mac OS, mac-OS
swappy.x86_64: W: spelling-error %description -l en_US stdout -> stout, std out, std-out
swappy.src: W: spelling-error Summary(en_US) macOS -> ma Cos, mac OS, mac-OS
swappy.src: W: spelling-error %description -l en_US macOS -> ma Cos, mac OS, mac-OS
swappy.src: W: spelling-error %description -l en_US stdout -> stout, std out, std-out
4 packages and 0 specfiles checked; 0 errors, 6 warnings.




Rpmlint (debuginfo)
-------------------
Checking: swappy-debuginfo-1.1.0-1.fc33.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
swappy.x86_64: W: spelling-error Summary(en_US) macOS -> ma Cos, mac OS, mac-OS
swappy.x86_64: W: spelling-error %description -l en_US macOS -> ma Cos, mac OS, mac-OS
swappy.x86_64: W: spelling-error %description -l en_US stdout -> stout, std out, std-out
swappy.x86_64: W: invalid-url URL: https://github.com/jtheoof/swappy <urlopen error [Errno -2] Name or service not known>
swappy-debuginfo.x86_64: W: invalid-url URL: https://github.com/jtheoof/swappy <urlopen error [Errno -2] Name or service not known>
swappy-debugsource.x86_64: W: invalid-url URL: https://github.com/jtheoof/swappy <urlopen error [Errno -2] Name or service not known>
3 packages and 0 specfiles checked; 0 errors, 6 warnings.



Source checksums
----------------
https://github.com/jtheoof/swappy/archive/v1.1.0/swappy-1.1.0.tar.gz :
  CHECKSUM(SHA256) this package     : b17cd548209947f10c4f8391f2a9dd4de16544abda00fc2290b4fd3815d70a50
  CHECKSUM(SHA256) upstream package : b17cd548209947f10c4f8391f2a9dd4de16544abda00fc2290b4fd3815d70a50


Requires
--------
swappy (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libcairo.so.2()(64bit)
    libgdk-3.so.0()(64bit)
    libgdk_pixbuf-2.0.so.0()(64bit)
    libgio-2.0.so.0()(64bit)
    libglib-2.0.so.0()(64bit)
    libgobject-2.0.so.0()(64bit)
    libgtk-3.so.0()(64bit)
    libm.so.6()(64bit)
    libnotify.so.4()(64bit)
    libpango-1.0.so.0()(64bit)
    libpangocairo-1.0.so.0()(64bit)
    rtld(GNU_HASH)

swappy-debuginfo (rpmlib, GLIBC filtered):

swappy-debugsource (rpmlib, GLIBC filtered):



Provides
--------
swappy:
    swappy
    swappy(x86-64)

swappy-debuginfo:
    debuginfo(build-id)
    swappy-debuginfo
    swappy-debuginfo(x86-64)

swappy-debugsource:
    swappy-debugsource
    swappy-debugsource(x86-64)



Generated by fedora-review 0.7.5 (5fa5b7e) last change: 2020-02-16
Command line :/usr/bin/fedora-review -b 1849384
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, C/C++, Shell-api
Disabled plugins: Perl, R, SugarActivity, Python, Haskell, Ocaml, PHP, Java, fonts
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 4 Bob Hepple 2020-06-29 00:53:16 UTC
Thanks again Aleksei!

I wrote to the swappy owner about fontawesome and had this reply:

"Considering the icons that I currently use, swappy should work with FA 4. But if I need to add more tools (and so icons) in the future, I will pick from FA 5, which has a lot more than FA 4 so it might not work in the future. Therefore I would still recommend using FA >=5, but it's technically OK to have FA >= 4 at the moment."

So I think we're OK for this release. I've added a note to the spec file to cover this point - hopefully FA-5 will be in fedora by the time this rears its head.

=====

I've become a bit stuck on the %gpgverify item. I've spent most of this morning trying to find out how to get over this step but I'm coming up with nothing - hopefully I've just missed something stupid ... anyway ... I have the URL for the .asc file and github publishes the GPG key ID as '6A6B35DBE9442683' - but I cannot for the life of me discover how to get the keyring/public key (from github or elsewhere) corresponding to that key ID!!

github has lots of help for people to create keys and sign artifacts but nothing AFAICS about how to get the keyring/public key and actually do the verification!

BTW 'gpg2 --recv-keys 0x6A6B35DBE9442683' gives no joy. Same for --search-key

So, my question is - do you know how to get the keyring/public key for github users?

I'll go ahead and request the repos for swappy based on your approval (thanks again) but I'll try to resolve gpgverify before I check anything in.

Comment 5 Bob Hepple 2020-06-29 00:54:42 UTC
On re-reading yr review I see you already looked for the keyring and came up with nothing - so I'll contact the author about this.

Comment 6 Bob Hepple 2020-06-29 01:44:24 UTC
I was lucky with the timezones and had a quick reply - but he says that he hasn't posted the key yet and won't be able to do it until he's back from holidays at the end of next week.

So (unless you object) I'll annotate the spec file accordingly with the %gpgverify lines commented out and kick off the build when the repos are ready tomorrow.

Comment 7 Aleksei Bavshin 2020-06-29 02:52:16 UTC
(In reply to Bob Hepple from comment #6)
> So (unless you object) I'll annotate the spec file accordingly with the
> %gpgverify lines commented out and kick off the build when the repos are
> ready tomorrow.

No objections. GPG verification is not required in the first place, just strongly recommended. And I still need to add gpgverify to some of my own packages :)

> hopefully FA-5 will be in fedora by the time this rears its head.

Doesn't seem to be that easy. There's a couple dozens of packages that show up in `dnf repoquery --whatdepends fontawesome-fonts --whatdepends fontawesome-fonts-web`. Some of them already expect 5.x (waybar, i3status-rs), a few more could be fixed with fontconfig aliases. And the rest are docs/web applications that refer to the specific font name or use old css/js font wrappers.
If it ever gets updated there likely will be compat package for 4.x.

Comment 8 Gwyn Ciesla 2020-06-29 14:02:40 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/swappy

Comment 9 Bob Hepple 2020-06-30 05:49:42 UTC
Building on koji:

SPEC URL: https://download.copr.fedorainfracloud.org/results/wef/swappy/fedora-31-x86_64/01514583-swappy/swappy.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/wef/swappy/fedora-31-x86_64/01514583-swappy/swappy-1.1.0-3.fc31.src.rpm

I had to add a patch to overcome compile errors on arm7 and i686 (do we still need i686?).

diff -Nur swappy-1.1.0-orig/src/config.c swappy-1.1.0/src/config.c
--- swappy-1.1.0-orig/src/config.c	2020-06-23 13:05:18.000000000 +1000
+++ swappy-1.1.0/src/config.c	2020-06-30 15:36:59.110245105 +1000
@@ -115,7 +115,11 @@
       config->line_size = line_size;
     } else {
       g_warning(
+#if defined(__arm__) || defined(__i686__)
+          "line_size is not a valid value: %lld - see man page for details",
+#else
           "line_size is not a valid value: %ld - see man page for details",
+#endif
           line_size);
     }
   } else {
@@ -132,7 +136,11 @@
       config->text_size = text_size;
     } else {
       g_warning(
+#if defined(__arm__) || defined(__i686__)
+          "text_size is not a valid value: %lld - see man page for details",
+#else
           "text_size is not a valid value: %ld - see man page for details",
+#endif
           text_size);
     }
   } else {

Comment 10 Fedora Update System 2020-06-30 05:53:46 UTC
FEDORA-2020-fc7bbe455c has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2020-fc7bbe455c

Comment 11 Fedora Update System 2020-06-30 06:03:06 UTC
FEDORA-2020-ac9ce08a6a has been submitted as an update to Fedora 32. https://bodhi.fedoraproject.org/updates/FEDORA-2020-ac9ce08a6a

Comment 12 Fedora Update System 2020-07-01 02:09:41 UTC
FEDORA-2020-fc7bbe455c has been pushed to the Fedora 31 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-fc7bbe455c \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-fc7bbe455c

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 13 Fedora Update System 2020-07-01 02:18:53 UTC
FEDORA-2020-ac9ce08a6a has been pushed to the Fedora 32 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-ac9ce08a6a \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-ac9ce08a6a

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 14 Fedora Update System 2020-07-07 01:34:56 UTC
FEDORA-2020-cb6ea509b7 has been pushed to the Fedora 31 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2020-cb6ea509b7`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-cb6ea509b7

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 15 Fedora Update System 2020-07-09 01:04:54 UTC
FEDORA-2020-ac9ce08a6a has been pushed to the Fedora 32 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 16 Fedora Update System 2020-07-13 01:55:20 UTC
FEDORA-2020-8a4d68c884 has been pushed to the Fedora 31 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2020-8a4d68c884`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-8a4d68c884

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 17 Fedora Update System 2020-07-21 01:56:45 UTC
FEDORA-2020-8a4d68c884 has been pushed to the Fedora 31 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.